blob: f7a9c18d26e7e6fd85397e0e9112e99366937f7d [file] [log] [blame]
brians343bc112013-02-10 01:53:46 +00001#! /bin/sh
2### BEGIN INIT INFO
3# Provides: starter
4# Required-Start: $remote_fs $syslog sshd $all
5# Required-Stop: $remote_fs $syslog
6# Default-Start: 2 3 4 5
7# Default-Stop: 0 1 6
8# Short-Description: AOS Startup Code
9# Description: Starts up all of the AOS-related things (FRC robot code).
10### END INIT INFO
11# pam_limits
12
13# Author: Spartan Robotics <spartanrobotics.org>
14
Brian Silverman8b34e272013-08-28 16:22:11 -070015# Install by placing in /etc/init.d/ and then `update-rc.d starter defaults`.
16
brians343bc112013-02-10 01:53:46 +000017# Do NOT "set -e"
18
19# PATH should only include /usr/* if it runs after the mountnfs.sh script
20PATH=/sbin:/usr/sbin:/bin:/usr/bin
21DESC="FRC robot code"
22NAME=starter
23DAEMON=/home/driver/robot_code/bin/$NAME.sh
24DAEMON_ARGS="/home/driver/robot_code/bin/start_list.txt"
25PIDFILE=/tmp/$NAME.pid
26SCRIPTNAME=/etc/init.d/$NAME
27
28# Exit if the package is not installed
29[ -x "$DAEMON" ] || exit 0
30
31# Read configuration variable file if it is present
32[ -r /etc/default/$NAME ] && . /etc/default/$NAME
33
34# Load the VERBOSE setting and other rcS variables
35. /lib/init/vars.sh
36
37# Define LSB log_* functions.
38# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
39# and status_of_proc is working.
40. /lib/lsb/init-functions
41VERBOSE=yes
42
43#
44# Function that starts the daemon/service
45#
46do_start()
47{
48 # Return
49 # 0 if daemon has been started
50 # 1 if daemon was already running
51 # 2 if daemon could not be started
52 start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
53 || return 1
54 start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
55 $DAEMON_ARGS \
56 || return 2
57 # Add code here, if necessary, that waits for the process to be ready
58 # to handle requests from services started subsequently which depend
59 # on this one. As a last resort, sleep for some time.
60}
61
62#
63# Function that stops the daemon/service
64#
65do_stop()
66{
67 # Return
68 # 0 if daemon has been stopped
69 # 1 if daemon was already stopped
70 # 2 if daemon could not be stopped
71 # other if a failure occurred
72 start-stop-daemon --stop --quiet --retry=INT/10/KILL/5 --pidfile $PIDFILE
73 RETVAL="$?"
74 [ "$RETVAL" = 2 ] && return 2
75 # Wait for children to finish too if this is a daemon that forks
76 # and if the daemon is only ever run from this initscript.
77 # If the above conditions are not satisfied then add some other code
78 # that waits for the process to drop all resources that could be
79 # needed by services started subsequently. A last resort is to
80 # sleep for some time.
81 #start-stop-daemon --stop --quiet --oknodo --retry=INT/10/KILL/5
82 #[ "$?" = 2 ] && return 2
83 sleep 10
84 # Many daemons don't delete their pidfiles when they exit.
85 rm -f $PIDFILE
86 return "$RETVAL"
87}
88
89#
90# Function that sends a SIGHUP to the daemon/service
91#
92do_reload() {
93 #
94 # If the daemon can reload its configuration without
95 # restarting (for example, when it is sent a SIGHUP),
96 # then implement that here.
97 #
98 start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
99 return 0
100}
101
102case "$1" in
103 start)
104 [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
105 do_start
106 case "$?" in
107 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
108 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
109 esac
110 ;;
111 stop)
112 [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
113 do_stop
114 case "$?" in
115 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
116 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
117 esac
118 ;;
119 status)
120 status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
121 ;;
122 #reload|force-reload)
123 #
124 # If do_reload() is not implemented then leave this commented out
125 # and leave 'force-reload' as an alias for 'restart'.
126 #
127 #log_daemon_msg "Reloading $DESC" "$NAME"
128 #do_reload
129 #log_end_msg $?
130 #;;
131 restart|force-reload)
132 #
133 # If the "reload" option is implemented then remove the
134 # 'force-reload' alias
135 #
136 log_daemon_msg "Restarting $DESC" "$NAME"
137 do_stop
138 case "$?" in
139 0|1)
140 do_start
141 case "$?" in
142 0) log_end_msg 0 ;;
143 1) log_end_msg 1 ;; # Old process is still running
144 *) log_end_msg 1 ;; # Failed to start
145 esac
146 ;;
147 *)
148 # Failed to stop
149 log_end_msg 1
150 ;;
151 esac
152 ;;
153 *)
154 #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
155 echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
156 exit 3
157 ;;
158esac
159
160: